%define anolis_release 1

%undefine _package_note_flags

%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

# Running the tests requires ocaml-ounit, which introduces a circular
# dependency (also involving ocaml-lwt).  The tests also require ocamlformat,
# introducing a second circular dependency.  Break the cycles with this
# conditional.
%bcond_with test

Name:           ocaml-bisect-ppx
Version:        2.8.1
Release:        %{anolis_release}%{?dist}
Summary:        Code coverage for OCaml and Reason

# The project as a whole is MIT.
# The embedded copy of highlight.js is BSD-3-Clause.
License:        MIT AND BSD-3-Clause
URL:            https://aantron.github.io/bisect_ppx/
Source0:        https://github.com/aantron/bisect_ppx/archive/%{version}/bisect_ppx-%{version}.tar.gz
# Adapt to ppxlib 0.26.0
# https://github.com/aantron/bisect_ppx/pull/400
Patch0:         %{name}-ppat-construct.patch
# Adapt to ppxlib 0.28.0
# https://github.com/anmonteiro/bisect_ppx/commit/cc442a08e3a2e0e18deb48f3a696076ac0986728
Patch1:         %{name}-ppxlib-0.28.0.patch

BuildRequires:  git-core
BuildRequires:  ocaml >= 4.02.0
BuildRequires:  ocaml-cmdliner-devel >= 1.0.0
BuildRequires:  ocaml-dune >= 2.7.0
BuildRequires:  ocaml-ppxlib-devel >= 0.21.0

%if %{with test}
BuildRequires:  ocamlformat
%endif

Obsoletes:      %{name}-doc < 2.5.0-1
Provides:       %{name}-doc = %{version}-%{release}

%description
Bisect_ppx is a code coverage tool for OCaml.  It helps you test
thoroughly by showing which parts of your code are *not* tested.  It is
a small preprocessor that inserts instrumentation at places in your
code, such as if-then-else and match expressions.  After you run tests,
Bisect_ppx gives a nice HTML report showing which places were visited
and which were missed.

Usage is simple - add package bisect_ppx when building tests, run your
tests, then run the Bisect_ppx report tool on the generated visitation
files.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-ppxlib-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n bisect_ppx-%{version} -p1

%build
%dune_build

%install
%dune_install

# Install the man page
mkdir -p %{buildroot}%{_mandir}/man1
_build/install/default/bin/bisect-ppx-report --help groff > \
  %{buildroot}%{_mandir}/man1/bisect-ppx-report.1

%generate_compatibility_deps

%if %{with test}
%check
%dune_check
%endif

%files -f .ofiles
%license LICENSE.md
%{_mandir}/man1/bisect-ppx-report.1*
%dir %{abidir}
%{abidir}/bisect-ppx-report-option.list

%files devel -f .ofiles-devel

%files doc
%doc doc/advanced.md doc/CHANGES README.md

%changelog
* Sat Mar 25 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 2.8.1-1
- Init from upstream
